

            {UNIT....UNIT...UNIT...UNIT...UNIT...UNIT}

 unit fonvect;

   INTERFACE
    uses fonscal,constype;

     procedure prodvect(vect1,vect2:vecteur;Var result:vecteur);
     procedure scalvect(lambda:real;x:vecteur;Var y:vecteur);
     procedure somme(vect1,vect2:vecteur;Var result:vecteur);
     procedure unitaire(vect1:vecteur;var result:vecteur);
     function prodscal(vect1,vect2:vecteur):real;
     function norm(x:vecteur):real;
     function angvect(vect1,vect2:vecteur):real;


    IMPLEMENTATION

     procedure prodvect(vect1,vect2:vecteur;Var result:vecteur);

       begin
         result[1]:=vect1[2]*vect2[3]-vect1[3]*vect2[2];
         result[2]:=vect1[3]*vect2[1]-vect1[1]*vect2[3];
         result[3]:=vect1[1]*vect2[2]-vect1[2]*vect2[1];
       end;

     procedure scalvect(lambda:real;x:vecteur;Var y:vecteur);
       var i:integer;
       begin
         for i:=1 to 3 do
         y[i]:=lambda*x[i];
       end;

     procedure somme(vect1,vect2:vecteur;Var result:vecteur);
       var i:integer;
       begin
         for i:=1 to 3 do
         result[i]:=vect1[i]+vect2[i];
       end;

     function prodscal(vect1,vect2:vecteur):real ;
       var i:integer;
           prod:real;
        begin
         prod:=0;
         for i:=1 to 3 do
          prod:=prod+vect1[i]*vect2[i];
          prodscal:=prod;
         end;

     function norm(x:vecteur):real;
        var i:integer;
            norma:real;

         begin
          norma:=0;
          for i:=1 to 3 do
          norma:=norma+x[i]*x[i];
          norm:=sqrt(norma);
         end;

     function angvect(vect1,vect2:vecteur):real;
         begin
          if((norm(vect1)=0) or  (norm(vect2)=0))
              then
                  begin
                   writeln('erreur:un des vecteurs est nul,angle ne');
                   writeln('signifie rien');
                  end;

          angvect:=arccos(prodscal(vect1,vect2)/norm(vect1)/norm(vect2));
         end;

      procedure unitaire(vect1:vecteur;var result:vecteur);
       begin

         scalvect(1/norm(vect1),vect1,result);
       end;
   end.


