PROGRAM ENZTOIJK;

{***********************************************
 * 
 * Calcule le changement de base ENZ ---> IJK
 *	r dans ENZ  en km
 *	V dans ENZ  en km/s
 
 *  connaissant
 *       r dans IJK
 *       V vitesse initiale absolue dans IJK
 *
 *  par leurs composantes dans la base gocentrique
 ************************************************}


uses wincrt,windos,fonscal,fonvect,constype,matrice;

var r,V:vecteur;  {DONNEES DANS ENZ}
    
    chr:char;
    P:mat33;  {Matrice de passage de IJK a ENZ}
    lat:real;

procedure DEMANDE;


BEGIN
writeln('     Donnez en  km le rayon vecteur dans I J K '); writeln;
write('      r[1] = ');readln(r[1]);
write('      r[2] = ');readln(r[2]);
write('      r[3] = ');readln(r[3]);

lat:=arctan(r[3]/sqrt(r[1]*r[1]+r[2]*r[2])) ;

writeln('     Donnez en  km/s les composantes du vecteur vitesse dans I, J, K');

writeln;
write('          V[1]= ');read(V[1]);
write('          V[2]= ');read(V[2]);
write('          V[3]= ');read(V[3]);
writeln;writeln;

END;

procedure CALCUL_MATRICE;
var alpha0:real;

BEGIN

if r[1]>=0 then alpha0:=arctan(r[2]/r[1]);

if r[1]<0 then   alpha0:=arctan(r[2]/r[1])+pi;

{CALCUL DE LA MATRICE DE PASSAGE DE IJK  ENZ}

P[1,1]:=-sin(alpha0);P[1,2]:=-sin(lat)*cos(alpha0);
P[1,3]:= cos(lat)*cos(alpha0);P[2,1]:=cos(alpha0);
P[2,2]:= -sin(lat)*sin(alpha0);P[2,3]:=cos(lat)*sin(alpha0);
P[3,1]:=0;P[3,2]:=cos(lat); P[3,3]:=sin(lat);

{ calcul de l'inverse de P passage de ENZ  IJK}

inversmat(P,P);

END;


procedure CALCUL_R_V;

Var K:vecteur;
    inclin:real;

BEGIN

   prodmatvect(P,r,r);
   prodmatvect(P,V,V);
   writeln;writeln;
   Writeln('     VOICI LES COMPOSANTES DANS E N Z DE LA POSITION-VITESSE (km et km/s');
   writeln;writeln;
   writeln('       r[1]= ',r[1]:6:2,'  km');
   writeln('       r[2]= ',r[2]:6:2,'  km');
   writeln('       r[3]= ',r[3]:6:2,'  km');
   writeln;
writeln;writeln;
   writeln('       V[1]= ',V[1]:6:3,'  km/s');
   writeln('       V[2]= ',V[2]:6:3,'  km/s');
   writeln('       V[3]= ',V[3]:6:3,'  km/s');
   writeln;
writeln;writeln;

END;



BEGIN
 writeLn('     ***********************************************');
 writeLn('     * Calcule le changement de base IJK ---> ENZ');
 writeLn('     *       r dans ENZ  en km');
 writeLn('     *       V dans ENZ  en km/s');

 writeLn('     *  connaissant:');
 writeLn('     *       r rayon vecteur initial dans IJK');
 writeLn('     *       V vitesse initiale absolue dans IJK');


 writeLn('     ************************************************');
DEMANDE;
CALCUL_MATRICE;
CALCUL_R_V;

Writeln('                  ***** NOTEZ VOS RESULTATS *****');Writeln;
Writeln('          ***** POUR QUITTER APPUYEZ SUR UNE TOUCHE ****');
chr:=readkey;

donewincrt;
END.

